<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApagaTipoContactoResponse StructType
 * @subpackage Structs
 */
class ApagaTipoContactoResponse extends AbstractStructBase
{
    /**
     * The ApagaTipoContactoResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ApagaTipoContactoResult;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for ApagaTipoContactoResponse
     * @uses ApagaTipoContactoResponse::setApagaTipoContactoResult()
     * @uses ApagaTipoContactoResponse::setMensagem()
     * @uses ApagaTipoContactoResponse::setSucesso()
     * @param bool $apagaTipoContactoResult
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($apagaTipoContactoResult = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setApagaTipoContactoResult($apagaTipoContactoResult)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get ApagaTipoContactoResult value
     * @return bool|null
     */
    public function getApagaTipoContactoResult()
    {
        return $this->ApagaTipoContactoResult;
    }
    /**
     * Set ApagaTipoContactoResult value
     * @param bool $apagaTipoContactoResult
     * @return \StructType\ApagaTipoContactoResponse
     */
    public function setApagaTipoContactoResult($apagaTipoContactoResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($apagaTipoContactoResult) && !is_bool($apagaTipoContactoResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($apagaTipoContactoResult)), __LINE__);
        }
        $this->ApagaTipoContactoResult = $apagaTipoContactoResult;
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\ApagaTipoContactoResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\ApagaTipoContactoResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ApagaTipoContactoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
